﻿<Graph ClassName="SOScheduling" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections.Generic;
using PX.Data;
using PX.Objects.CS;
using PX.Objects.SO;
using PL;
using PX.Objects.AR;

namespace DispatchExtension
{
	public class SOScheduling : PXGraph<SOScheduling>
	{
		public PXCancel<SOLine> Cancel;

        public PXFilter<DispatchFilter> Filter;
        public PXProcessingJoin<
            SOLine,
            LeftJoin<SOOrderType,
                On<SOOrderType.orderType, Equal<SOLine.orderType>>,
            LeftJoin<SOOrder, 
                On<SOOrder.orderType, Equal<SOLine.orderType>, 
                And<SOOrder.orderNbr, Equal<SOLine.orderNbr>>>>>,
            Where2<
                Where<SOLineExt.usrConfirmShipment, NotEqual<Attrib.directDelivery>,
                    And<SOOrderTypeExt.usrDispatch, Equal<True>>>,
                And<Where<SOOrder.status, Equal<SOOrderStatus.backOrder>, 
                    Or<SOOrder.status, Equal<SOOrderStatus.open>>>>>>
            SalesOrders;

        public SOScheduling()
        {
            SalesOrders.SetSelected<SOLineExt.usrSelected>();
            SalesOrders.SetProcessDelegate(UpdateSODetails);
        }

        public static void UpdateSODetails(List<SOLine> lines)
        {
            foreach (SOLine line in lines)
            {
                var lineExt = PXCache<SOLine>.GetExtension<SOLineExt>(line);

                PXDatabase.Update<SOLine>(
                                new PXDataFieldAssign<SOLineExt.usrForeCastDate>(lineExt.UsrForeCastDate),
                                new PXDataFieldRestrict<SOLine.orderType>(line.OrderType),
                                new PXDataFieldRestrict<SOLine.orderNbr>(line.OrderNbr),
                                new PXDataFieldRestrict<SOLine.lineNbr>(line.LineNbr)
                                );

            }
        }


        #region Event Handlers
        public void SOLine_RowSelected(PXCache cache, PXRowSelectedEventArgs e)
        {
            var row = (SOLine)e.Row;
            if (row == null) return;

            PXUIFieldAttribute.SetEnabled<SOLineExt.usrForeCastDate>(cache, null, true);
        }

        #endregion

        #region DispatchFilter
        [Serializable]
        public class DispatchFilter : IBqlTable
        {
            public abstract class deliveryDateFrom : IBqlField { }
            [PXDate()]
            [PXUIField(DisplayName = "Requested On Date From")]
            public virtual DateTime? DeliveryDateFrom { get; set; }

            public abstract class deliveryDateTo : IBqlField { }
            [PXDate()]
            [PXUIField(DisplayName = "Requested On Date To")]
            public virtual DateTime? DeliveryDateTo { get; set; }

            [Customer]
            public abstract class customerName : IBqlField { }
            public virtual int? CustomerName { get; set; }

            public abstract class orderNbr : IBqlField { }
            [PXString(15)]
            [PXUIField(DisplayName = "Order No.")]
            [PXSelector(typeof(Search2<
                SOOrder.orderNbr, 
                LeftJoin<SOOrderType, 
                    On<SOOrder.orderType, Equal<SOOrderType.orderType>>>, 
                Where<SOOrderTypeExt.usrDispatch, Equal<True>>>), Filterable = true)]
            public virtual string OrderNbr { get; set; }

            public abstract class shippingType : IBqlField { }
            [PXString(5)]
            [PXUIField(DisplayName = "Shipping Type")]
            [DispatchAttrib.List]
            public virtual string ShippingType { get; set; }
        }
        #endregion

    }
}]]></CDATA>
</Graph>